Use https for git.postgresq.org
    
As a follow-up to 533511081221670e7183dce529c7665cb04a4e5e, move all
git.postgresql.org links on developer/backend to https.

diff --git a/templates/pages/developer/backend.html b/templates/pages/developer/backend.html
index f8d3327..7226b61 100644
--- a/templates/pages/developer/backend.html
+++ b/templates/pages/developer/backend.html
@@ -46,14 +46,14 @@ echo "0, 0," | awk -F, '{printf "%d, %d\n", $1 + 145, $2 + 45}'
 or Unix Domain sockets. It is loaded into a string, and passed to the <a
 href="https://wiki.postgresql.org/wiki/Backend_flowchart#parser">parser,</a>
 where the lexical scanner, <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/scan.l">scan.l,</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/scan.l">scan.l,</a>
 breaks the query up into tokens(words). The parser uses <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/gram.y">gram.y</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/gram.y">gram.y</a>
 and the tokens to identify the query type, and load the proper
 query-specific structure, like <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">CreateStmt</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">CreateStmt</a>
 or <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">SelectStmt.</a></p>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">SelectStmt.</a></p>
 
 <p>The statement is then identified as complex (<i>SELECT / INSERT /
 UPDATE / DELETE</i>) or a simple, e.g <i> CREATE USER, ANALYZE, </i>,
@@ -62,26 +62,26 @@ functions in <a href="https://wiki.postgresql.org/wiki/Backend_flowchart#command
 Complex statements require more handling.</p>
 
 <p>The parser takes a complex query, and creates a <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">Query</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">Query</a>
 structure that contains all the elements used by complex queries.
 Query.qual holds the <i>WHERE</i> clause qualification, which is filled
 in by <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_clause.c">transformWhereClause().</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_clause.c">transformWhereClause().</a>
 Each table referenced in the query is represented by a <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">RangeTableEntry,</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/parsenodes.h">RangeTableEntry,</a>
 and they are linked together to form the <i>range table</i> of the
 query, which is generated by <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_clause.c">transformFromClause().</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_clause.c">transformFromClause().</a>
 Query.rtable holds the query's range table.</p>
 
 <p>Certain queries, like <i>SELECT,</i> return columns of data. Other
 queries, like <i>INSERT</i> and <i>UPDATE,</i> specify the columns
 modified by the query. These column references are converted to <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/primnodes.h">TargetEntry</a>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/include/nodes/primnodes.h">TargetEntry</a>
 entries, which are linked together to make up the <i>target list</i> of
 the query. The target list is stored in Query.targetList, which is
 generated by <a
-href="http://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_target.c">transformTargetList().</a></p>
+href="https://git.postgresql.org/gitweb/?p=postgresql.git;a=blob;f=src/backend/parser/parse_target.c">transformTargetList().</a></p>
 
 <p>Other query elements, like aggregates(<i>SUM()</i>), <i>GROUP
 BY,</i> and <i>ORDER BY</i> are also stored in their own Query