diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index f6cb5d4..4fff035 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -2624,9 +2624,9 @@ init(bool is_no_vacuum)
 		}
 	};
 	static const char *const DDLINDEXes[] = {
-		"alter table pgbench_branches add primary key (bid)",
-		"alter table pgbench_tellers add primary key (tid)",
-		"alter table pgbench_accounts add primary key (aid)"
+		"create index pgbench_branches_bid on pgbench_branches using btree (bid)",
+		"create index pgbench_tellers_tid on pgbench_tellers using btree (tid)",
+		"create index pgbench_accounts_aid on pgbench_accounts using btree (aid)"
 	};
 	static const char *const DDLKEYs[] = {
 		"alter table pgbench_tellers add foreign key (bid) references pgbench_branches",